importScripts("https://d3js.org/d3.v5.min.js");

onmessage = function(event) {
  var nodes = event.data.nodes,
    links = event.data.links,
    height = event.data.height,
    width = event.data.width;

  var simulation = d3
    .forceSimulation(nodes)
    .force("link", d3.forceLink(links).id(d => d.id))
    .force("charge", d3.forceManyBody())
    .force("center", d3.forceCenter(width / 2, height / 2))
    .stop();

  for (
    var i = 0,
      n = Math.ceil(
        Math.log(simulation.alphaMin()) / Math.log(1 - simulation.alphaDecay())
      );
    i < n;
    ++i
  ) {
    postMessage({ type: "tick", progress: i / n });
    simulation.tick();
  }

  postMessage({ type: "end", nodes: nodes, links: links });
};
