import requests
from bs4 import BeautifulSoup
import re
import collections
import pandas as pd

Paper = collections.namedtuple(
    "Paper", "title journal abstract year authors keywords url"
)


def format_name(fullname):
    # remove anything in parens, eg. nickname
    fullname = re.sub(r"\([^)]*\)", "", fullname)
    seperator = " "
    return seperator.join([name.strip() for name in fullname.split(",")][::-1])


def format_title(title):
    return re.sub(r" +", " ", title)

